#!/usr/bin/env python
#
# Server program for autots
#
# Copyright (C) 2008 Maximilian Hoegner
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

import gtk
import pexpect,os,sys
import subprocess

DIR=os.path.expanduser('~/Dauerhaftes Verzeichnis')

def open_uri(button,uri):
	subprocess.Popen(['epiphany',uri])

gtk.link_button_set_uri_hook(open_uri)

if not os.path.exists(DIR):
	os.mkdir(DIR)

w=gtk.Dialog("Benutzerverzeichnis", buttons=(gtk.STOCK_OK,gtk.RESPONSE_OK,gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL))

n=gtk.Entry()
reg=gtk.LinkButton('http://localhost/apache2-default/benutzerverzeichnis/',label='Verzeichnis erstellen...')
w.vbox.pack_start(reg)
w.vbox.pack_start(gtk.HSeparator(),False,False,5)
w.vbox.pack_start(gtk.Label("Benutzername"))
w.vbox.pack_start(n)
w.vbox.pack_start(gtk.Label("Passwort"))
p=gtk.Entry()
p.set_visibility(False)
w.vbox.pack_start(p,True,True,0)
w.show_all()

w.set_default_response (gtk.RESPONSE_OK)
n.set_activates_default(True)
p.set_activates_default(True)
n.grab_focus()

while True:
	r=w.run()

	if r==gtk.RESPONSE_CANCEL:
		sys.exit()

	user = n.get_text()
	pw = p.get_text()

	c=pexpect.spawn('fusermount',['-u',DIR])
	print c.readlines()

	c=pexpect.spawn('curlftpfs',['localhost',DIR,'-o','user='+user])
	c.expect("Enter host password for user")
	c.sendline(pw)

	print c.readlines()
	print c.close()
	print c.status

	if c.status!=0:
		d = gtk.MessageDialog(w, gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT, gtk.MESSAGE_ERROR, gtk.BUTTONS_OK, 'Falscher Benutzername oder falsches Passwort!')
		p.set_text('')
		d.run()
		d.destroy()
	else:
		break

w.destroy()

def open(*args):
	subprocess.Popen(['thunar',DIR])

w=gtk.Dialog("Verzeichnis",None,gtk.DIALOG_MODAL,(gtk.STOCK_DISCONNECT,gtk.RESPONSE_OK))
w.vbox.pack_start(gtk.Label("Verzeichnis verbunden als "+user))
o=gtk.Button(stock=gtk.STOCK_OPEN)
o.connect('clicked',open)
w.vbox.pack_start(o,True,True,10)
w.show_all()
w.run()
w.destroy()

u=pexpect.spawn('fusermount',['-u',DIR])
print u.readlines()

u=pexpect.spawn('fusermount',['-z','-u',DIR])
print u.readlines()

c.terminate(True)
